import base64
from typing import Any

import requests


class NtfyHelper:
    @staticmethod
    def send_message(userName: str,
                     password: str,
                     baseUrl: str,
                     topicName: str,
                     message: str,
                     tags: list[str],
                     headers: dict[str, Any] | None = None) -> None:
        base64Encoded = base64.b64encode(f'{userName}:{password}'.encode('utf-8'))

        baseHeaders = {
            'Authorization': f'Basic {base64Encoded.decode("utf-8")}',
            'Tags': ','.join(tags)
        }
        if headers is not None:
            baseHeaders.update(headers)

        response = requests.post(f'{baseUrl}/{topicName}', data=message, headers=baseHeaders)
        response.raise_for_status()
